/*
   orxonox - the future of 3D-vertical-scrollers

   Copyright (C) 2004 orx

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   ### File Specific:
   main-programmer: David Hasenfratz
   co-programmer: ...

   this file extends the framework file, so it renders what i want.
*/

#include <stdlib.h>

#include "framework.h"
#include "movie_player.h"

MoviePlayer* movie_player;
float start_time;

void Framework::moduleInit(int argc, char** argv)
{
  if( argc <= 1)
  {
    printf("Wrong arguments try following notations:\n");
    printf("./movie_player_test [media_file]\n");
    exit(0);
  }

  movie_player = new MoviePlayer(argv[1]);
  movie_player->printInformation();
  
  //start_time = atoi(argv[2]);
  start_time = 0;
}

void Framework::moduleEventHandler(SDL_Event* event)
{
  switch (event->type)
  {
    case SDL_KEYDOWN:
      switch (event->key.keysym.sym)
      {
        case SDLK_1:
          movie_player->start(start_time);
          break;
        case SDLK_2:
          movie_player->resume();
          break;
        case SDLK_3:
          movie_player->pause();
          break;
        case SDLK_4:
          movie_player->stop();
          break;
        case SDLK_9:
          movie_player->setSpeed(movie_player->getSpeed() - 0.5);
          PRINTF(0)("speed: %f\n", movie_player->getSpeed());
          break;
        case SDLK_0:
          movie_player->setSpeed(movie_player->getSpeed() + 0.5);
          PRINTF(0)("speed: %f\n", movie_player->getSpeed());
          break;
      }
  }
}

void Framework::moduleTick(float dt)
{
  movie_player->tick(dt);
}

void Framework::moduleDraw(void) const
{
  movie_player->draw();
}


void Framework::moduleHelp(void) const
{

}
